var Fis06200_DimeSc_Controller = function(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil){
    
    var self = this;
    
    self.addAgendamento = function(widget){
        widget.newRow(); 
        widget.getField('DTREFINI').isVisible = true;
    };
    
    self.cancelAgendamento = function(args){
        General.backOrCancel(args); 
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };
    
    self.editAgendamento = function(widget){
        General.edit(widget); 
        this.periodicidadeOnChange(widget);
    };
    
    self.saveAgendamento = function(widget){
        if (widget.isValid()) {
		    var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));
            
            if(d1.getTime() > d2.getTime()){
                if(((widget.currentRow.CDINSCESTA == '') || (widget.currentRow.CDINSCESTA == null)) && (widget.currentRow.CDEMPRESA)){
                    widget.currentRow.CDINSCESTA = "T";
                }
                
                widget.currentRow.NRORG = getLocalVar('NRORG');
                
                General.callRestEngine('fis_acessorias#/saveAgendamentoDimeSc','Row', widget.currentRow).then(
                    function(success){
                        General.changeWidgetAcessibility(widget.widgets, true);
                        ScreenService.showMessage('Agendado com sucesso.');
                        ScreenService.goBack();
                        widget.getField('DTREFINI').isVisible = true;
                        widget.reload();
                    },
                    function(error){
                        ScreenService.showMessage(error.data.error);
                    }
                );
		    } else {
		        ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
		    }
            
        } else {
			// @todo create messages class
			ScreenService.showMessage("Preencha todos os campos corretamente!");
		}
    };
    
    self.downloadArquivoAgendado = function(dimeScWidget) {
        var downloadRoute;
        var fileName;
        
        if(dimeScWidget.hasCheckedRows()){
            var rows = dimeScWidget.getCheckedRows();
            rows.forEach(function(row){
                downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;
                
                window.open(downloadRoute + fileName);
            });
        } 
        else {
            var row = dimeScWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;
            
            window.open(downloadRoute + fileName);
        }
        
    };
    
    self.deleteAgendamento = function(widget){
        widget.currentRow.NRORG = getLocalVar('NRORG');
        
        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
        	General.callRestEngine('fis_acessorias#/deleteAgendamentoDimeSc','Row', widget.currentRow).then(
                function(success){
                    ScreenService.showMessage('Deletado com sucesso.');
                    ScreenService.goBack();
                    widget.reload();
                },
                function(error){
                    ScreenService.showMessage(error.data.error);
                }
            );
        });
    };

    self.periodicidadeOnChange = function(widget){
        if(widget.currentRow.IDPERIAGEN == 0){
            widget.getField('DTREFINI').isVisible = true;
        }
        else if(widget.currentRow.IDPERIAGEN == 1){
            widget.getField('DTREFINI').isVisible = false;
            if((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != ""){
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        }
        else if(widget.currentRow.IDPERIAGEN == 2){
            widget.getField('DTREFINI').isVisible = false;
            if((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != ""){
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };
    
    /**
     * Função para a chamada de Exportação
     */
    self.exportarDimeSc = function(dimeScWidget){
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if(dimeScWidget.isValid()){
            // Verifica se a parametrização não foi carregada e verificada
            if(!parametrizacaoWasLoaded(dimeScWidget)){
                return;
            }
            var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDimeSc');
            // Define propriedades na widget principal com valores dos fields
            // da tab de parametrização
            preenhcerPropriedadesWidgetPrincipal(dimeScWidget, parametrosWidget);
            var row = dimeScWidget.currentRow;
            var route = 'fis#/exportarDimeSc';
            var message = Messages_fiscal.EXPORTANDO_DIME_SC;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    /**
     * Função auxiliar que verifica se a tab de parametrização foi aberta ao exportar,
     * através da propriedade 'empresasLoaded'.
     */ 
    var parametrizacaoWasLoaded = function(dimeScWidget){
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdEmpresa = dimeScWidget.currentRow.CDEMPRESA;
        parametrosWidget = templateManager.container.getWidget('parametrosGeraisDimeSc');
        // Verifica se a propriedade (CDEMPRESA) está setada para a empresa selecionada
        parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdEmpresa];
        
        // Verifica se a widget de parametrização não foi aberta antes de
        // clicar no botão de exportar
        if(!parametrizacaoWasLoaded){
            // Muda a propriedade para que a parametrização seja obrigatória
            parametrosWidget.parametersRequired = true;
            // Exibe mensagem indicando a obrigatoriedae da verificação dos parametros
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR).
            then(function(){
                // Abre a widget/tab de parâmetros
                openTabParametrosGerais(parametrosWidget);
            });
            // Retorna false, indicando que a parametrização não foi previamente aberta
            return false;
        }
        // Retorna true, caso a parametrização já tenha sido aberta
        return true;
    };
    /**
     * Função auxiliar que abre a tab de parâmetros pela primeira vez.
     */ 
    var openTabParametrosGerais = function(parametrosWidget){
        // Recarrega os dados (dataSource) parametrizados
        parametrosWidget.reload().then(function(){
            // Redesenha os dados carregados na tab
            parametrosWidget.redraw();
        });
        // Define a tab de parametricação como ativa
        parametrosWidget.activate();
    };
    /**
     * Função auxiliar que cria e preenche propriedades da widget principal,
     * com os valores das fields da tab de parâmetros
     */
    var preenhcerPropriedadesWidgetPrincipal = function(dimeScWidget, parametrosWidget){
        dimeScWidget.currentRow.STCLASSE            = parametrosWidget.currentRow.STCLASSE;
        dimeScWidget.currentRow.STNUMTRAB           = parametrosWidget.currentRow.STNUMTRAB;
        dimeScWidget.currentRow.STTIPODECLARACAO    = parametrosWidget.currentRow.STTIPODECLARACAO;
        dimeScWidget.currentRow.STTIPOREGIME        = parametrosWidget.currentRow.STTIPOREGIME;
        dimeScWidget.currentRow.STCONSOLIDADA       = parametrosWidget.currentRow.STCONSOLIDADA;
        dimeScWidget.currentRow.STCENTRALIZADA      = parametrosWidget.currentRow.STCENTRALIZADA;
        dimeScWidget.currentRow.STMOVIMENTO         = parametrosWidget.currentRow.STMOVIMENTO;
        dimeScWidget.currentRow.STTRIBUTARIO        = parametrosWidget.currentRow.STTRIBUTARIO;
        dimeScWidget.currentRow.STESCCONTABIL       = parametrosWidget.currentRow.STESCCONTABIL;
        dimeScWidget.currentRow.STINCFISCAL         = parametrosWidget.currentRow.STINCFISCAL;
        dimeScWidget.currentRow.STGERINVENTARIO     = parametrosWidget.currentRow.STGERINVENTARIO;
        dimeScWidget.currentRow.STTPATIVIDADE       = parametrosWidget.currentRow.STTPATIVIDADE;
    };
    /**
     * Função para salvar os parâmetros informados - ou caso eles já existam,
     * apenas os confirmam para a exportação
     */
    self.salvarParametrizacao = function(parametrosWidget){
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if(parametrosWidget.isValid()){
            var dimeScWidget = templateManager.container.getWidget('dime-sc');
            preencherCamposAbstratosParaSalvar(parametrosWidget);
            var filter = [
                {
                    "name": "P_CDEMPRESA",
                    "operator": "=",
                    "value": dimeScWidget.currentRow.CDEMPRESA
                },
                {
                    "name": "P_CDINSCRICAO",
                    "operator": "=",
                    "value": parametrosWidget.currentRow.CDINSCRICAO
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar('NRORG')
                }
            ];
            
            General.callRestEngine('fis_acessorias#/crud/paramdeclaces_DimeSc', 'FilterData', filter).then(function (result) {
                result = result.dataset.paramdeclaces_DimeSc;
                
                if(result.length == 0)
                    parametrosWidget.currentRow.__is_new = true;
                    
                parametrosWidget.saveRow()
                .then(function(){
                    // Seta os parametros como verificados pelo usuário
                    setParametersVerified(parametrosWidget);
                    // Ativa a widget principal
                    dimeScWidget.activate();
                    dimeScWidget.currentWidget = dimeScWidget;
                    /**
                     * Verifica se a tela de parâmetros foi exibida devido a uma tentativa
                     * de exportação. Caso positivo, a exportação é efetuada
                     */
                    if(parametrosWidget.parametersRequired){
                        self.exportarDimeSc(dimeScWidget);
                        // Valida a propriedade para false, caso a tela de parametros seja
                        // novamente aberta. E assim não haverá exportação sempre ao sair
                        parametrosWidget.parametersRequired = false;
                    }
                });
            });
        }
    };
    
    var preencherCamposAbstratosParaSalvar = function(parametrosWidget){
        parametrosWidget.currentRow.CDCAMPO1    = parametrosWidget.currentRow.STCLASSE;
        parametrosWidget.currentRow.CDCAMPO2    = parametrosWidget.currentRow.STNUMTRAB;
        parametrosWidget.currentRow.CDCAMPO3    = parametrosWidget.currentRow.STTIPODECLARACAO;
        parametrosWidget.currentRow.CDCAMPO4    = parametrosWidget.currentRow.STTIPOREGIME;
        parametrosWidget.currentRow.CDCAMPO5    = parametrosWidget.currentRow.STCONSOLIDADA;
        parametrosWidget.currentRow.CDCAMPO6    = parametrosWidget.currentRow.STCENTRALIZADA;
        parametrosWidget.currentRow.CDCAMPO7    = parametrosWidget.currentRow.STMOVIMENTO;
        parametrosWidget.currentRow.CDCAMPO8    = parametrosWidget.currentRow.STTRIBUTARIO;
        parametrosWidget.currentRow.CDCAMPO9    = parametrosWidget.currentRow.STESCCONTABIL;
        parametrosWidget.currentRow.CDCAMPO10   = parametrosWidget.currentRow.STINCFISCAL;
        parametrosWidget.currentRow.CDCAMPO12   = parametrosWidget.currentRow.STGERINVENTARIO;
        parametrosWidget.currentRow.CDCAMPO13   = parametrosWidget.currentRow.STTPATIVIDADE;
    };
    
    /**
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário
     */
    var setParametersVerified = function(parametrosWidget){
        var currentRow = parametrosWidget.currentRow;
        var dimeScFiscalIsSelected = parametrosWidget.name == "parametrosGeraisDimeSc";
        if (dimeScFiscalIsSelected) {
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
        else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    }; 
    /**
     * Função que é invocada após o carregamento do dataSource. Caso é 
     * retornado algo, adiciona à currentRow o primeiro indice de data[] - caso
     * contrário, é setada em forma de newRow;
     */ 
    self.setLoadedParameters = function(parametrosWidget){
        var dimeScWidget = templateManager.container.getWidget("dime-sc");
        if(parametrosWidget.dataSource.data.length > 0){
            // Seta a currentRow como sendo o primeiro indice do data[] retornado
            parametrosWidget.moveToFirst();
            // Redesenha na widget principal, os fields com os valores da nova 
            // currentRow
            parametrosWidget.redraw();
        }else{
            // Seta a widget em modo de novo dado, para inserir a parametrização
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = dimeScWidget.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = dimeScWidget.currentRow.NMEMPRESA;
    };
    /**
     * Função invocada ao sair da widget de parametros, que seta os mesmos como 
     * verificados
     */ 
    self.beforeExitParametrosGerais = function(parametrosWidget){
        // Seta a parametrização como verificada somente se a widget não estiver
        // em modo de inserção, mas sim de verificação
        if(!parametrosWidget.isNewRow()){
            setParametersVerified(parametrosWidget);
        }
    };
    /**
     * Função que é invocada ao alterar o field CDINSCESTA,
     * alterando a propriedade enable da tab de parâmetros
     */ 
    self.inscricaoOnChange = function(dimeScWidget){
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDimeSc');
        // Variável booleana que é setada como true, caso alguma inscrição seja 
        // selecionada
        var inscricaoIsSelect = !!dimeScWidget.currentRow.CDINSCESTA;
        parametrosWidget.enabled = inscricaoIsSelect;
    };
    /**
     * Função que é invocada ao alterar o field GERAREGISTRO,
     * alterando a propriedade readOnly e validations do fieldGroup dadosContabeis
     */ 
    self.geraRegistroOnChange = function(dimeScWidget){
        if(dimeScWidget.currentRow.GERAREGISTRO == "S"){
            dimeScWidget.fields.forEach(function(data){
				if(data.fieldGroup == "dadosContabeis" && data.name != "GERAREGISTRO"){
					data.readOnly = false;
					data.validations.required = true;
				}
			});
        }else{
            dimeScWidget.fields.forEach(function(data){
				if(data.fieldGroup == "dadosContabeis" && data.name != "GERAREGISTRO"){
					data.readOnly = true;
					data.validations = {};
				}
			});
        }
		dimeScWidget.currentRow.CDATIVO     = "";
		dimeScWidget.currentRow.CDPASSIVO   = "";
		dimeScWidget.currentRow.CDDRE       = "";
		dimeScWidget.currentRow.CDDESPESAS  = "";
		dimeScWidget.currentRow.DTREFCTB    = "";
    };
    
    self.restauraPadraoDadosContabeis = function(dimeScWidget){
        dimeScWidget.getField('CDATIVO').readOnly       = true;
        dimeScWidget.getField('CDATIVO').validations    = {};
        dimeScWidget.getField('CDPASSIVO').readOnly     = true;
        dimeScWidget.getField('CDPASSIVO').validations  = {};
        dimeScWidget.getField('CDDRE').readOnly         = true;
        dimeScWidget.getField('CDDRE').validations      = {};
        dimeScWidget.getField('CDDESPESAS').readOnly    = true;
        dimeScWidget.getField('CDDESPESAS').validations = {};
        dimeScWidget.getField('DTREFCTB').readOnly      = true;
        dimeScWidget.getField('DTREFCTB').validations   = {};
    };
 
};
Configuration(function(ContextRegister){
    ContextRegister.register("Fis06200_DimeSc_Controller", Fis06200_DimeSc_Controller);
});